; ========================================================;
;                                                         ;
;    ws2_32.inc for Easy Code 2.0 64-bit Masm projects    ;
;                   (version 1.0.2)                       ;
;                                                         ;
;          Copyright  Ramon Sala - 2016-2021             ;
;                                                         ;
; ========================================================;

IFNDEF WS2_32_INC
WS2_32_INC     EQU     1

IFNDEF INCL_WINSOCK_API_TYPEDEFS
    INCL_WINSOCK_API_TYPEDEFS                       EQU     0
ENDIF

IFNDEF INCL_WINSOCK_API_PROTOTYPES
    INCL_WINSOCK_API_PROTOTYPES                     EQU     1
ENDIF

IFNDEF FD_SETSIZE
    FD_SETSIZE                                      EQU     64
ENDIF

IOCPARM_MASK                                        EQU     07FH

IOC_VOID                                            EQU     020000000H
IOC_OUT                                             EQU     040000000H
IOC_IN                                              EQU     080000000H
IOC_INOUT                                           EQU     0C0000000H

IPPROTO_IP                                          EQU     0
IPPROTO_ICMP                                        EQU     1
IPPROTO_IGMP                                        EQU     2
IPPROTO_GGP                                         EQU     3
IPPROTO_TCP                                         EQU     6
IPPROTO_PUP                                         EQU     12
IPPROTO_UDP                                         EQU     17
IPPROTO_IDP                                         EQU     22
IPPROTO_ND                                          EQU     77
IPPROTO_RAW                                         EQU     255
IPPROTO_MAX                                         EQU     256

IPPORT_ECHO                                         EQU     7
IPPORT_DISCARD                                      EQU     9
IPPORT_SYSTAT                                       EQU     11
IPPORT_DAYTIME                                      EQU     13
IPPORT_NETSTAT                                      EQU     15
IPPORT_FTP                                          EQU     21
IPPORT_TELNET                                       EQU     23
IPPORT_SMTP                                         EQU     25
IPPORT_TIMESERVER                                   EQU     37
IPPORT_NAMESERVER                                   EQU     42
IPPORT_WHOIS                                        EQU     43
IPPORT_MTP                                          EQU     57
IPPORT_TFTP                                         EQU     69
IPPORT_RJE                                          EQU     77
IPPORT_FINGER                                       EQU     79
IPPORT_TTYLINK                                      EQU     87
IPPORT_SUPDUP                                       EQU     95
IPPORT_EXECSERVER                                   EQU     512
IPPORT_LOGINSERVER                                  EQU     513
IPPORT_CMDSERVER                                    EQU     514
IPPORT_EFSSERVER                                    EQU     520
IPPORT_BIFFUDP                                      EQU     512
IPPORT_WHOSERVER                                    EQU     513
IPPORT_ROUTESERVER                                  EQU     520
IPPORT_RESERVED                                     EQU     1024

IMPLINK_IP                                          EQU     155
IMPLINK_LOWEXPER                                    EQU     156
IMPLINK_HIGHEXPER                                   EQU     158

IN_CLASSA_NET                                       EQU     0FF000000H
IN_CLASSA_NSHIFT                                    EQU     24
IN_CLASSA_HOST                                      EQU     000FFFFFFH
IN_CLASSA_MAX                                       EQU     128

IN_CLASSB_NET                                       EQU     0FFFF0000H
IN_CLASSB_NSHIFT                                    EQU     16
IN_CLASSB_HOST                                      EQU     00000FFFFH
IN_CLASSB_MAX                                       EQU     65536

IN_CLASSC_NET                                       EQU     0FFFFFF00H
IN_CLASSC_NSHIFT                                    EQU     8
IN_CLASSC_HOST                                      EQU     0000000FFH

IN_CLASSD_NET                                       EQU     0F0000000H
IN_CLASSD_NSHIFT                                    EQU     28
IN_CLASSD_HOST                                      EQU     00FFFFFFFH

INADDR_ANY                                          EQU     000000000H
INADDR_LOOPBACK                                     EQU     07F000001H
INADDR_BROADCAST                                    EQU     0FFFFFFFFH
INADDR_NONE                                         EQU     0FFFFFFFFH

ADDR_ANY                                            EQU     INADDR_ANY

SOCKET_ERROR                                        EQU     (-1)

FROM_PROTOCOL_INFO                                  EQU     (-1)

SOCK_STREAM                                         EQU     1
SOCK_DGRAM                                          EQU     2
SOCK_RAW                                            EQU     3
SOCK_RDM                                            EQU     4
SOCK_SEQPACKET                                      EQU     5

SO_DEBUG                                            EQU     00001H
SO_ACCEPTCONN                                       EQU     00002H
SO_REUSEADDR                                        EQU     00004H
SO_KEEPALIVE                                        EQU     00008H
SO_DONTROUTE                                        EQU     00010H
SO_BROADCAST                                        EQU     00020H
SO_USELOOPBACK                                      EQU     00040H
SO_LINGER                                           EQU     00080H
SO_OOBINLINE                                        EQU     00100H
SO_DONTLINGER                                       EQU     0FFFFFF7FH
SO_EXCLUSIVEADDRUSE                                 EQU     0FFFFFFFBH

SO_SNDBUF                                           EQU     01001H
SO_RCVBUF                                           EQU     01002H
SO_SNDLOWAT                                         EQU     01003H
SO_RCVLOWAT                                         EQU     01004H
SO_SNDTIMEO                                         EQU     01005H
SO_RCVTIMEO                                         EQU     01006H
SO_ERROR                                            EQU     01007H
SO_TYPE                                             EQU     01008H

SO_GROUP_ID                                         EQU     02001H
SO_GROUP_PRIORITY                                   EQU     02002H
SO_MAX_MSG_SIZE                                     EQU     02003H
SO_PROTOCOL_INFOA                                   EQU     02004H
SO_PROTOCOL_INFOW                                   EQU     02005H

IFDEF APP_UNICODE
    SO_PROTOCOL_INFO                                EQU     SO_PROTOCOL_INFOW
ELSE
    SO_PROTOCOL_INFO                                EQU     SO_PROTOCOL_INFOA
ENDIF

PVD_CONFIG                                          EQU     03001H
SO_CONDITIONAL_ACCEPT                               EQU     03002H

TCP_NODELAY                                         EQU     00001H

AF_UNSPEC                                           EQU     0
AF_UNIX                                             EQU     1
AF_INET                                             EQU     2
AF_IMPLINK                                          EQU     3
AF_PUP                                              EQU     4
AF_CHAOS                                            EQU     5
AF_NS                                               EQU     6
AF_IPX                                              EQU     AF_NS
AF_ISO                                              EQU     7
AF_OSI                                              EQU     AF_ISO
AF_ECMA                                             EQU     8
AF_DATAKIT                                          EQU     9
AF_CCITT                                            EQU     10
AF_SNA                                              EQU     11
AF_DECnet                                           EQU     12
AF_DLI                                              EQU     13
AF_LAT                                              EQU     14
AF_HYLINK                                           EQU     15
AF_APPLETALK                                        EQU     16
AF_NETBIOS                                          EQU     17
AF_VOICEVIEW                                        EQU     18
AF_FIREFOX                                          EQU     19
AF_UNKNOWN1                                         EQU     20
AF_BAN                                              EQU     21
AF_ATM                                              EQU     22
AF_INET6                                            EQU     23
AF_CLUSTER                                          EQU     24
AF_12844                                            EQU     25
AF_IRDA                                             EQU     26
AF_NETDES                                           EQU     28
AF_MAX                                              EQU     29

PF_UNSPEC                                           EQU     AF_UNSPEC
PF_UNIX                                             EQU     AF_UNIX
PF_INET                                             EQU     AF_INET
PF_IMPLINK                                          EQU     AF_IMPLINK
PF_PUP                                              EQU     AF_PUP
PF_CHAOS                                            EQU     AF_CHAOS
PF_NS                                               EQU     AF_NS
PF_IPX                                              EQU     AF_IPX
PF_ISO                                              EQU     AF_ISO
PF_OSI                                              EQU     AF_OSI
PF_ECMA                                             EQU     AF_ECMA
PF_DATAKIT                                          EQU     AF_DATAKIT
PF_CCITT                                            EQU     AF_CCITT
PF_SNA                                              EQU     AF_SNA
PF_DECnet                                           EQU     AF_DECnet
PF_DLI                                              EQU     AF_DLI
PF_LAT                                              EQU     AF_LAT
PF_HYLINK                                           EQU     AF_HYLINK
PF_APPLETALK                                        EQU     AF_APPLETALK
PF_VOICEVIEW                                        EQU     AF_VOICEVIEW
PF_FIREFOX                                          EQU     AF_FIREFOX
PF_UNKNOWN1                                         EQU     AF_UNKNOWN1
PF_BAN                                              EQU     AF_BAN
PF_ATM                                              EQU     AF_ATM
PF_INET6                                            EQU     AF_INET6
PF_MAX                                              EQU     AF_MAX

SOL_SOCKET                                          EQU     0FFFFH

SOMAXCONN                                           EQU     07FFFFFFFH

MSG_OOB                                             EQU     00001H
MSG_PEEK                                            EQU     00002H
MSG_DONTROUTE                                       EQU     00004H
MSG_PARTIAL                                         EQU     08000H
MSG_INTERRUPT                                       EQU     00010H
MSG_MAXIOVLEN                                       EQU     16

MAXGETHOSTSTRUCT                                    EQU     1024

FD_READ_BIT                                         EQU     0
FD_READ                                             EQU     (1 SHL FD_READ_BIT)
FD_WRITE_BIT                                        EQU     1
FD_WRITE                                            EQU     (1 SHL FD_WRITE_BIT)
FD_OOB_BIT                                          EQU     2
FD_OOB                                              EQU     (1 SHL FD_OOB_BIT)
FD_ACCEPT_BIT                                       EQU     3
FD_ACCEPT                                           EQU     (1 SHL FD_ACCEPT_BIT)
FD_CONNECT_BIT                                      EQU     4
FD_CONNECT                                          EQU     (1 SHL FD_CONNECT_BIT)
FD_CLOSE_BIT                                        EQU     5
FD_CLOSE                                            EQU     (1 SHL FD_CLOSE_BIT)
FD_QOS_BIT                                          EQU     6
FD_QOS                                              EQU     (1 SHL FD_QOS_BIT)
FD_GROUP_QOS_BIT                                    EQU     7
FD_GROUP_QOS                                        EQU     (1 SHL FD_GROUP_QOS_BIT)
FD_ROUTING_INTERFACE_CHANGE_BIT                     EQU     8
FD_ROUTING_INTERFACE_CHANGE                         EQU     (1 SHL FD_ROUTING_INTERFACE_CHANGE_BIT)
FD_ADDRESS_LIST_CHANGE_BIT                          EQU     9
FD_ADDRESS_LIST_CHANGE                              EQU     (1 SHL FD_ADDRESS_LIST_CHANGE_BIT)
FD_MAX_EVENTS                                       EQU     10
FD_ALL_EVENTS                                       EQU     ((1 SHL FD_MAX_EVENTS)-1)

IFNDEF WSABASEERR
    WSABASEERR                                      EQU     (10000
    WSAEINTR                                        EQU     (WSABASEERR+4)
    WSAEBADF                                        EQU     (WSABASEERR+9)
    WSAEACCES                                       EQU     (WSABASEERR+13)
    WSAEFAULT                                       EQU     (WSABASEERR+14)
    WSAEINVAL                                       EQU     (WSABASEERR+22)
    WSAEMFILE                                       EQU     (WSABASEERR+24)
    WSAEWOULDBLOCK                                  EQU     (WSABASEERR+35)
    WSAEINPROGRESS                                  EQU     (WSABASEERR+36)
    WSAEALREADY                                     EQU     (WSABASEERR+37)
    WSAENOTSOCK                                     EQU     (WSABASEERR+38)
    WSAEDESTADDRREQ                                 EQU     (WSABASEERR+39)
    WSAEMSGSIZE                                     EQU     (WSABASEERR+40)
    WSAEPROTOTYPE                                   EQU     (WSABASEERR+41)
    WSAENOPROTOOPT                                  EQU     (WSABASEERR+42)
    WSAEPROTONOSUPPORT                              EQU     (WSABASEERR+43)
    WSAESOCKTNOSUPPORT                              EQU     (WSABASEERR+44)
    WSAEOPNOTSUPP                                   EQU     (WSABASEERR+45)
    WSAEPFNOSUPPORT                                 EQU     (WSABASEERR+46)
    WSAEAFNOSUPPORT                                 EQU     (WSABASEERR+47)
    WSAEADDRINUSE                                   EQU     (WSABASEERR+48)
    WSAEADDRNOTAVAIL                                EQU     (WSABASEERR+49)
    WSAENETDOWN                                     EQU     (WSABASEERR+50)
    WSAENETUNREACH                                  EQU     (WSABASEERR+51)
    WSAENETRESET                                    EQU     (WSABASEERR+52)
    WSAECONNABORTED                                 EQU     (WSABASEERR+53)
    WSAECONNRESET                                   EQU     (WSABASEERR+54)
    WSAENOBUFS                                      EQU     (WSABASEERR+55)
    WSAEISCONN                                      EQU     (WSABASEERR+56)
    WSAENOTCONN                                     EQU     (WSABASEERR+57)
    WSAESHUTDOWN                                    EQU     (WSABASEERR+58)
    WSAETOOMANYREFS                                 EQU     (WSABASEERR+59)
    WSAETIMEDOUT                                    EQU     (WSABASEERR+60)
    WSAECONNREFUSED                                 EQU     (WSABASEERR+61)
    WSAELOOP                                        EQU     (WSABASEERR+62)
    WSAENAMETOOLONG                                 EQU     (WSABASEERR+63)
    WSAEHOSTDOWN                                    EQU     (WSABASEERR+64)
    WSAEHOSTUNREACH                                 EQU     (WSABASEERR+65)
    WSAENOTEMPTY                                    EQU     (WSABASEERR+66)
    WSAEPROCLIM                                     EQU     (WSABASEERR+67)
    WSAEUSERS                                       EQU     (WSABASEERR+68)
    WSAEDQUOT                                       EQU     (WSABASEERR+69)
    WSAESTALE                                       EQU     (WSABASEERR+70)
    WSAEREMOTE                                      EQU     (WSABASEERR+71)
    WSASYSNOTREADY                                  EQU     (WSABASEERR+91)
    WSAVERNOTSUPPORTED                              EQU     (WSABASEERR+92)
    WSANOTINITIALISED                               EQU     (WSABASEERR+93)
    WSAEDISCON                                      EQU     (WSABASEERR+101)
    WSAENOMORE                                      EQU     (WSABASEERR+102)
    WSAECANCELLED                                   EQU     (WSABASEERR+103)
    WSAEINVALIDPROCTABLE                            EQU     (WSABASEERR+104)
    WSAEINVALIDPROVIDER                             EQU     (WSABASEERR+105)
    WSAEPROVIDERFAILEDINIT                          EQU     (WSABASEERR+106)
    WSASYSCALLFAILURE                               EQU     (WSABASEERR+107)
    WSASERVICE_NOT_FOUND                            EQU     (WSABASEERR+108)
    WSATYPE_NOT_FOUND                               EQU     (WSABASEERR+109)
    WSA_E_NO_MORE                                   EQU     (WSABASEERR+110)
    WSA_E_CANCELLED                                 EQU     (WSABASEERR+111)
    WSAEREFUSED                                     EQU     (WSABASEERR+112)
    WSAHOST_NOT_FOUND                               EQU     (WSABASEERR+1001)
    WSATRY_AGAIN                                    EQU     (WSABASEERR+1002)
    WSANO_RECOVERY                                  EQU     (WSABASEERR+1003)
    WSANO_DATA                                      EQU     (WSABASEERR+1004)
    WSA_QOS_RECEIVERS                               EQU     (WSABASEERR+1005)
    WSA_QOS_SENDERS                                 EQU     (WSABASEERR+1006)
    WSA_QOS_NO_SENDERS                              EQU     (WSABASEERR+1007)
    WSA_QOS_NO_RECEIVERS                            EQU     (WSABASEERR+1008)
    WSA_QOS_REQUEST_CONFIRMED                       EQU     (WSABASEERR+1009)
    WSA_QOS_ADMISSION_FAILURE                       EQU     (WSABASEERR+1010)
    WSA_QOS_POLICY_FAILURE                          EQU     (WSABASEERR+1011)
    WSA_QOS_BAD_STYLE                               EQU     (WSABASEERR+1012)
    WSA_QOS_BAD_OBJECT                              EQU     (WSABASEERR+1013)
    WSA_QOS_TRAFFIC_CTRL_ERROR                      EQU     (WSABASEERR+1014)
    WSA_QOS_GENERIC_ERROR                           EQU     (WSABASEERR+1015)
    WSA_QOS_ESERVICETYPE                            EQU     (WSABASEERR+1016)
    WSA_QOS_EFLOWSPEC                               EQU     (WSABASEERR+1017)
    WSA_QOS_EPROVSPECBUF                            EQU     (WSABASEERR+1018)
    WSA_QOS_EFILTERSTYLE                            EQU     (WSABASEERR+1019)
    WSA_QOS_EFILTERTYPE                             EQU     (WSABASEERR+1020)
    WSA_QOS_EFILTERCOUNT                            EQU     (WSABASEERR+1021)
    WSA_QOS_EOBJLENGTH                              EQU     (WSABASEERR+1022)
    WSA_QOS_EFLOWCOUNT                              EQU     (WSABASEERR+1023)
    WSA_QOS_EUNKOWNPSOBJ                            EQU     (WSABASEERR+1024)
    WSA_QOS_EPOLICYOBJ                              EQU     (WSABASEERR+1025)
    WSA_QOS_EFLOWDESC                               EQU     (WSABASEERR+1026)
    WSA_QOS_EPSFLOWSPEC                             EQU     (WSABASEERR+1027)
    WSA_QOS_EPSFILTERSPEC                           EQU     (WSABASEERR+1028)
    WSA_QOS_ESDMODEOBJ                              EQU     (WSABASEERR+1029)
    WSA_QOS_ESHAPERATEOBJ                           EQU     (WSABASEERR+1030)
    WSA_QOS_RESERVED_PETYPE                         EQU     (WSABASEERR+1031)
ENDIF

HOST_NOT_FOUND                                      EQU     WSAHOST_NOT_FOUND
TRY_AGAIN                                           EQU     WSATRY_AGAIN
NO_RECOVERY                                         EQU     WSANO_RECOVERY
NO_DATA                                             EQU     WSANO_DATA
WSANO_ADDRESS                                       EQU     WSANO_DATA
NO_ADDRESS                                          EQU     WSANO_ADDRESS

WSAEVENT                                            EQU     HANDLE
WSAOVERLAPPED                                       EQU     OVERLAPPED

WSA_IO_PENDING                                      EQU     ERROR_IO_PENDING
WSA_IO_INCOMPLETE                                   EQU     ERROR_IO_INCOMPLETE
WSA_INVALID_HANDLE                                  EQU     ERROR_INVALID_HANDLE
WSA_INVALID_PARAMETER                               EQU     ERROR_INVALID_PARAMETER
WSA_NOT_ENOUGH_MEMORY                               EQU     ERROR_NOT_ENOUGH_MEMORY
WSA_OPERATION_ABORTED                               EQU     ERROR_OPERATION_ABORTED

WSA_INVALID_EVENT                                   EQU     NULL
WSA_MAXIMUM_WAIT_EVENTS                             EQU     MAXIMUM_WAIT_OBJECTS
WSA_WAIT_FAILED                                     EQU     WAIT_FAILED
WSA_WAIT_EVENT_0                                    EQU     WAIT_OBJECT_0
WSA_WAIT_IO_COMPLETION                              EQU     WAIT_IO_COMPLETION
WSA_WAIT_TIMEOUT                                    EQU     WAIT_TIMEOUT
WSA_INFINITE                                        EQU     INFINITE

WSADESCRIPTION_LEN                                  EQU     256
WSASYS_STATUS_LEN                                   EQU     128

CF_ACCEPT                                           EQU     00000H
CF_REJECT                                           EQU     00001H
CF_DEFER                                            EQU     00002H

SD_RECEIVE                                          EQU     000H
SD_SEND                                             EQU     001H
SD_BOTH                                             EQU     002H

SG_UNCONSTRAINED_GROUP                              EQU     001H
SG_CONSTRAINED_GROUP                                EQU     002H

MAX_PROTOCOL_CHAIN                                  EQU     7

BASE_PROTOCOL                                       EQU     1
LAYERED_PROTOCOL                                    EQU     0

WSAPROTOCOL_LEN                                     EQU     255

PFL_MULTIPLE_PROTO_ENTRIES                          EQU     00000001H
PFL_RECOMMENDED_PROTO_ENTRY                         EQU     00000002H
PFL_HIDDEN                                          EQU     00000004H
PFL_MATCHES_PROTOCOL_ZERO                           EQU     00000008H

XP1_CONNECTIONLESS                                  EQU     00000001H
XP1_GUARANTEED_DELIVERY                             EQU     00000002H
XP1_GUARANTEED_ORDER                                EQU     00000004H
XP1_MESSAGE_ORIENTED                                EQU     00000008H
XP1_PSEUDO_STREAM                                   EQU     00000010H
XP1_GRACEFUL_CLOSE                                  EQU     00000020H
XP1_EXPEDITED_DATA                                  EQU     00000040H
XP1_CONNECT_DATA                                    EQU     00000080H
XP1_DISCONNECT_DATA                                 EQU     00000100H
XP1_SUPPORT_BROADCAST                               EQU     00000200H
XP1_SUPPORT_MULTIPOINT                              EQU     00000400H
XP1_MULTIPOINT_CONTROL_PLANE                        EQU     00000800H
XP1_MULTIPOINT_DATA_PLANE                           EQU     00001000H
XP1_QOS_SUPPORTED                                   EQU     00002000H
XP1_INTERRUPT                                       EQU     00004000H
XP1_UNI_SEND                                        EQU     00008000H
XP1_UNI_RECV                                        EQU     00010000H
XP1_IFS_HANDLES                                     EQU     00020000H
XP1_PARTIAL_MESSAGE                                 EQU     00040000H

BIGENDIAN                                           EQU     0000H
LITTLEENDIAN                                        EQU     0001H               

SECURITY_PROTOCOL_NONE                              EQU     0000H

JL_SENDER_ONLY                                      EQU     001H
JL_RECEIVER_ONLY                                    EQU     002H
JL_BOTH                                             EQU     004H

WSA_FLAG_OVERLAPPED                                 EQU     001H
WSA_FLAG_MULTIPOINT_C_ROOT                          EQU     002H
WSA_FLAG_MULTIPOINT_C_LEAF                          EQU     004H
WSA_FLAG_MULTIPOINT_D_ROOT                          EQU     008H
WSA_FLAG_MULTIPOINT_D_LEAF                          EQU     010H

IOC_UNIX                                            EQU     000000000H
IOC_WS2                                             EQU     008000000H
IOC_PROTOCOL                                        EQU     010000000H
IOC_VENDOR                                          EQU     018000000H

TH_NETDEV                                           EQU     000000001H
TH_TAPI                                             EQU     000000002H

SERVICE_MULTIPLE                                    EQU     1

NS_ALL                                              EQU     0
NS_SAP                                              EQU     1
NS_NDS                                              EQU     2
NS_PEER_BROWSE                                      EQU     3
NS_SLP                                              EQU     5
NS_DHCP                                             EQU     6
NS_TCPIP_LOCAL                                      EQU     10
NS_TCPIP_HOSTS                                      EQU     11
NS_DNS                                              EQU     12
NS_NETBT                                            EQU     13
NS_WINS                                             EQU     14
NS_NBP                                              EQU     20
NS_MS                                               EQU     30
NS_STDA                                             EQU     31
NS_NTDS                                             EQU     32
NS_X500                                             EQU     40
NS_NIS                                              EQU     41
NS_NISPLUS                                          EQU     42
NS_WRQ                                              EQU     50
NS_NETDES                                           EQU     60

RES_UNUSED_1                                        EQU     000000001H
RES_FLUSH_CACHE                                     EQU     000000002H
IFNDEF RES_SERVICE
    RES_SERVICE                                     EQU     000000004H
ENDIF

SERVICE_TYPE_VALUE_IPXPORTA                         EQU     <IpxSocket>
SERVICE_TYPE_VALUE_IPXPORTW                         EQU     L("IpxSocket")
SERVICE_TYPE_VALUE_SAPIDA                           EQU     <SapId>
SERVICE_TYPE_VALUE_SAPIDW                           EQU     L("SapId")
SERVICE_TYPE_VALUE_TCPPORTA                         EQU     <TcpPort>
SERVICE_TYPE_VALUE_TCPPORTW                         EQU     L("TcpPort")
SERVICE_TYPE_VALUE_UDPPORTA                         EQU     <UdpPort>
SERVICE_TYPE_VALUE_UDPPORTW                         EQU     L("UdpPort")
SERVICE_TYPE_VALUE_OBJECTIDA                        EQU     <ObjectId>
SERVICE_TYPE_VALUE_OBJECTIDW                        EQU     L("ObjectId")

COMP_EQUAL                                          EQU     0
COMP_NOTLESS                                        EQU     1

LUP_DEEP                                            EQU     00001H
LUP_CONTAINERS                                      EQU     00002H
LUP_NOCONTAINERS                                    EQU     00004H
LUP_NEAREST                                         EQU     00008H
LUP_RETURN_NAME                                     EQU     00010H
LUP_RETURN_TYPE                                     EQU     00020H
LUP_RETURN_VERSION                                  EQU     00040H
LUP_RETURN_COMMENT                                  EQU     00080H
LUP_RETURN_ADDR                                     EQU     00100H
LUP_RETURN_BLOB                                     EQU     00200H
LUP_RETURN_ALIASES                                  EQU     00400H
LUP_RETURN_QUERY_STRING                             EQU     00800H
LUP_RETURN_ALL                                      EQU     00FF0H
LUP_RES_SERVICE                                     EQU     08000H
LUP_FLUSHCACHE                                      EQU     01000H
LUP_FLUSHPREVIOUS                                   EQU     02000H

RESULT_IS_ALIAS                                     EQU     00001H

RNRSERVICE_REGISTER                                 EQU     0
RNRSERVICE_DEREGISTER                               EQU     1
RNRSERVICE_DELETE                                   EQU     2


;======================================== Structures ======================================;
IFNDEF GUID
    GUID STRUCT ALIGNMODE
        Data1   DD  ?
        Data2   DW  ?
        Data3   DW  ?
        Data4   DB  8 DUP(?)
    GUID ENDS
ENDIF

IFNDEF fd_set
    fd_set STRUCT ALIGNMODE
        fd_count       DD ?
        fd_array       DD FD_SETSIZE DUP(?)
    fd_set ENDS
ENDIF

IFNDEF timeval
    timeval STRUCT ALIGNMODE
        tv_sec  DD ?
        tv_usec DD ?
    timeval ENDS
ENDIF

IFNDEF hostent
    hostent STRUCT ALIGNMODE
        h_name         XWORD ?
        h_aliases      XWORD ?
        h_addrtype     DW    ?
        h_length       DW    ?
        IFDEF APP_WIN64
                       DD    ?
        ENDIF
        h_addr_list    XWORD ?
    hostent ENDS
ENDIF

IFNDEF netent
    netent STRUCT ALIGNMODE
        n_name       DD ?
        n_aliases    DD ?
        n_addrtype   DW ?
        n_net        DD ?
    netent ENDS
ENDIF

IFNDEF servent
    servent STRUCT ALIGNMODE
        s_name       DD ?
        s_aliases    DD ?
        s_port       DW ?
        s_proto      DD ?
    servent ENDS
ENDIF

IFNDEF protoent
    protoent STRUCT ALIGNMODE
        p_name       DD ?
        p_aliases    DD ?
        p_proto      DW ?
    protoent ENDS
ENDIF

IFNDEF in_addr
    in_addr STRUCT ALIGNMODE
        Union S_un
            STRUCT S_un_b
                s_b1 DB ?
                s_b2 DB ?
                s_b3 DB ?
                s_b4 DB ?
            ENDS
            STRUCT S_un_w
                s_w1 DW ?
                s_w2 DW ?
            ENDS
            S_addr   DD ?
        ENDS
    in_addr ENDS
ENDIF

IFNDEF sockaddr_in
    sockaddr_in STRUCT ALIGNMODE
        sin_family     DW ?
        sin_port       DW ?
        sin_addr       DD ?
        sin_zero       DB 8 DUP(?)
    sockaddr_in ENDS
ENDIF

IFNDEF WSADATA 
    WSADATA STRUCT ALIGNMODE
        wVersion       DW   ?
        wHighVersion   DW   ?
        szDescription  DB   (WSADESCRIPTION_LEN+1) DUP(?)
        szSystemStatus DB   (WSASYS_STATUS_LEN+1) DUP(?)
        iMaxSockets    DW   ?
        iMaxUdpDg      DW   ?
        _padding_      DB   2 DUP(?)
        lpVendorInfo   XPTR ?
    WSADATA ENDS
ENDIF

IFNDEF sockaddr
    sockaddr STRUCT ALIGNMODE
        sa_family      DW ?
        sa_data        DB 14 DUP(?)
    sockaddr ENDS
ENDIF

IFNDEF sockproto
    sockproto STRUCT ALIGNMODE
        sp_family    DW ?
        sp_protocol  DW ?
    sockproto ENDS
ENDIF

IFNDEF linger
    linger STRUCT ALIGNMODE
        l_onoff      DW ?
        l_linger     DW ?
    linger ENDS
ENDIF

IFNDEF FLOWSPEC
    FLOWSPEC STRUCT ALIGNMODE
        TokenRate          DD ?
        TokenBucketSize    DD ?
        PeakBandwidth      DD ?
        Latency            DD ?
        DelayVariation     DD ?
        ServiceType        DD ?
        MaxSduSize         DD ?
        MinimumPolicedSize DD ?
    FLOWSPEC ENDS
ENDIF

WSABUF STRUCT ALIGNMODE
    len DD   ?
    buf XPTR ?
WSABUF ENDS

QualityOfService STRUCT ALIGNMODE
    SendingFlowspec   FLOWSPEC <>
    ReceivingFlowspec FLOWSPEC <>
    ProviderSpecific  WSABUF <>
QualityOfService ENDS

WSANETWORKEVENTS STRUCT ALIGNMODE
    lNetworkEvents DD ?
    iErrorCode     DD FD_MAX_EVENTS DUP(?)
WSANETWORKEVENTS ENDS

WSAPROTOCOLCHAIN STRUCT ALIGNMODE
    ChainLen     DD ?
    ChainEntries DD MAX_PROTOCOL_CHAIN DUP(?)
WSAPROTOCOLCHAIN ENDS

WSAPROTOCOL_INFOA STRUCT ALIGNMODE
    dwServiceFlags1    DD ?
    dwServiceFlags2    DD ?
    dwServiceFlags3    DD ?
    dwServiceFlags4    DD ?
    dwProviderFlags    DD ?
    ProviderId         GUID <>
    dwCatalogEntryId   DD ?
    ProtocolChain      WSAPROTOCOLCHAIN <>
    iVersion           DD ?
    iAddressFamily     DD ?
    iMaxSockAddr       DD ?
    iMinSockAddr       DD ?
    iSocketType        DD ?
    iProtocol          DD ?
    iProtocolMaxOffset DD ?
    iNetworkByteOrder  DD ?
    iSecurityScheme    DD ?
    dwMessageSize      DD ?
    dwProviderReserved DD ?
    szProtocol         DB WSAPROTOCOL_LEN+1 DUP(?)
WSAPROTOCOL_INFOA ENDS

WSAPROTOCOL_INFOW STRUCT ALIGNMODE
    dwServiceFlags1    DD ?
    dwServiceFlags2    DD ?
    dwServiceFlags3    DD ?
    dwServiceFlags4    DD ?
    dwProviderFlags    DD ?
    ProviderId         GUID <>
    dwCatalogEntryId   DD ?
    ProtocolChain      WSAPROTOCOLCHAIN <>
    iVersion           DD ?
    iAddressFamily     DD ?
    iMaxSockAddr       DD ?
    iMinSockAddr       DD ?
    iSocketType        DD ?
    iProtocol          DD ?
    iProtocolMaxOffset DD ?
    iNetworkByteOrder  DD ?
    iSecurityScheme    DD ?
    dwMessageSize      DD ?
    dwProviderReserved DD ?
    szProtocol         DW WSAPROTOCOL_LEN+1 DUP(?)
WSAPROTOCOL_INFOW ENDS

IFNDEF BLOB
    BLOB STRUCT ALIGNMODE
        cbSize    DD   ?
        pBlobData XPTR ?
    BLOB ENDS
ENDIF

SOCKET_ADDRESS STRUCT ALIGNMODE
    lpSockaddr      XPTR ?
    iSockaddrLength DD   ?
SOCKET_ADDRESS ENDS

CSADDR_INFO STRUCT ALIGNMODE
    LocalAddr   SOCKET_ADDRESS <>
    RemoteAddr  SOCKET_ADDRESS <>
    iSocketType DD ?
    iProtocol   DD ?
CSADDR_INFO ENDS

SOCKET_ADDRESS_LIST STRUCT ALIGNMODE
    iAddressCount DD ?
    Address       SOCKET_ADDRESS <>
SOCKET_ADDRESS_LIST ENDS

AFPROTOCOLS STRUCT ALIGNMODE
    iAddressFamily DD ?
    iProtocol      DD ?
AFPROTOCOLS ENDS

WSAVERSION STRUCT ALIGNMODE
    dwVersion DD ?
    ecHow     DD ?
WSAVERSION ENDS

WSAQUERYSETA STRUCT ALIGNMODE
    dwSize                  DD   ?
    lpszServiceInstanceName XPTR ?
    lpServiceClassId        XPTR ?
    lpVersion               XPTR ?
    lpszComment             XPTR ?
    dwNameSpace             DD   ?
    lpNSProviderId          XPTR ?
    lpszContext             XPTR ?
    dwNumberOfProtocols     DD   ?
    lpafpProtocols          XPTR ?
    lpszQueryString         XPTR ?
    dwNumberOfCsAddrs       DD   ?
    lpcsaBuffer             XPTR ?
    dwOutputFlags           DD   ?
    lpBlob                  XPTR ?
WSAQUERYSETA ENDS

WSAQUERYSETW STRUCT ALIGNMODE
    dwSize                  DD   ?
    lpszServiceInstanceName XPTR ?
    lpServiceClassId        XPTR ?
    lpVersion               XPTR ?
    lpszComment             XPTR ?
    dwNameSpace             DD   ?
    lpNSProviderId          XPTR ?
    lpszContext             XPTR ?
    dwNumberOfProtocols     DD   ?
    lpafpProtocols          XPTR ?
    lpszQueryString         XPTR ?
    dwNumberOfCsAddrs       DD   ?
    lpcsaBuffer             XPTR ?
    dwOutputFlags           DD   ?
    lpBlob                  XPTR ?
WSAQUERYSETW ENDS

WSANSCLASSINFOA STRUCT ALIGNMODE
    lpszName    XPTR ?
    dwNameSpace DD   ?
    dwValueType DD   ?
    dwValueSize DD   ?
    lpValue     XPTR ?
WSANSCLASSINFOA ENDS

WSANSCLASSINFOW STRUCT ALIGNMODE
    lpszName    XPTR ?
    dwNameSpace DD   ?
    dwValueType DD   ?
    dwValueSize DD   ?
    lpValue     XPTR ?
WSANSCLASSINFOW ENDS

WSASERVICECLASSINFOA STRUCT ALIGNMODE
    lpServiceClassId     XPTR ?
    lpszServiceClassName XPTR ?
    dwCount              DD   ?
    lpClassInfos         XPTR ?
WSASERVICECLASSINFOA ENDS

WSASERVICECLASSINFOW STRUCT ALIGNMODE
    lpServiceClassId     XPTR ?
    lpszServiceClassName XPTR ?
    dwCount              DD   ?
    lpClassInfos         XPTR ?
WSASERVICECLASSINFOW ENDS

WSANAMESPACE_INFOA STRUCT ALIGNMODE
    NSProviderId   GUID <>
    dwNameSpace    DD   ?
    fActive        DD   ?
    dwVersion      DD   ?
    lpszIdentifier XPTR ?
WSANAMESPACE_INFOA ENDS

WSANAMESPACE_INFOW STRUCT ALIGNMODE
    NSProviderId   GUID <>
    dwNameSpace    DD   ?
    fActive        DD   ?
    dwVersion      DD   ?
    lpszIdentifier XPTR ?
WSANAMESPACE_INFOW ENDS


;======================================== Functions =======================================;
FreeAddrInfoEx PROTO :XWORD
FreeAddrInfoExW PROTO :XWORD
FreeAddrInfoW PROTO :XWORD
GetAddrInfoExA PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
GetAddrInfoExCancel PROTO :XWORD
GetAddrInfoExOverlappedResult PROTO :XWORD
GetAddrInfoExW PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
GetAddrInfoW PROTO :XWORD,:XWORD,:XWORD,:XWORD
GetHostNameW PROTO :XWORD,:XWORD
GetNameInfoW PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
InetNtopW PROTO :XWORD,:XWORD,:XWORD,:XWORD
InetPtonW PROTO :XWORD,:XWORD,:XWORD
SetAddrInfoExA PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
SetAddrInfoExW PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WEP PROTO
WPUCompleteOverlappedRequest PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAccept PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAddressToStringA PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAddressToStringW PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAdvertiseProvider PROTO :XWORD,:XWORD
WSAAsyncGetHostByAddr PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAsyncGetHostByName PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAsyncGetProtoByName PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAsyncGetProtoByNumber PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAsyncGetServByName PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD ,:XWORD
WSAAsyncGetServByPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAAsyncSelect PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSACancelAsyncRequest PROTO :XWORD
WSACancelBlockingCall PROTO
WSACleanup PROTO
WSACloseEvent PROTO :XWORD
WSAConnect PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAConnectByList PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAConnectByNameA PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAConnectByNameW PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSACreateEvent PROTO
WSADuplicateSocketA PROTO :XWORD,:XWORD,:XWORD
WSADuplicateSocketW PROTO :XWORD,:XWORD,:XWORD
WSAEnumNameSpaceProvidersA PROTO :XWORD,:XWORD
WSAEnumNameSpaceProvidersExA PROTO :XWORD,:XWORD
WSAEnumNameSpaceProvidersExW PROTO :XWORD,:XWORD
WSAEnumNameSpaceProvidersW PROTO :XWORD,:XWORD
WSAEnumNetworkEvents PROTO :XWORD,:XWORD,:XWORD
WSAEnumProtocolsA PROTO :XWORD,:XWORD,:XWORD
WSAEnumProtocolsW PROTO :XWORD,:XWORD,:XWORD
WSAEventSelect PROTO :XWORD,:XWORD,:XWORD
WSAGetLastError PROTO
WSAGetOverlappedResult PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAGetQOSByName PROTO :XWORD,:XWORD,:XWORD
WSAGetServiceClassInfoA PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSAGetServiceClassInfoW PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSAGetServiceClassNameByClassIdA PROTO :XWORD,:XWORD,:XWORD
WSAGetServiceClassNameByClassIdW PROTO :XWORD,:XWORD,:XWORD
WSAHtonl PROTO :XWORD,:XWORD,:XWORD
WSAHtons PROTO :XWORD,:XWORD,:XWORD
WSAInstallServiceClassA PROTO :XWORD
WSAInstallServiceClassW PROTO :XWORD
WSAIoctl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAIsBlocking PROTO
WSAJoinLeaf PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSALookupServiceBeginA PROTO :XWORD,:XWORD,:XWORD
WSALookupServiceBeginW PROTO :XWORD,:XWORD,:XWORD
WSALookupServiceEnd PROTO :XWORD
WSALookupServiceNextA PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSALookupServiceNextW PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSANSPIoctl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSANtohl PROTO :XWORD,:XWORD,:XWORD
WSANtohs PROTO :XWORD,:XWORD,:XWORD
WSAPoll PROTO :XWORD,:XWORD,:XWORD
WSAProviderCompleteAsyncCall PROTO :XWORD,:XWORD
WSAProviderConfigChange PROTO :XWORD,:XWORD,:XWORD
WSARecv PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSARecvDisconnect PROTO :XWORD,:XWORD
WSARecvFrom PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSARemoveServiceClass PROTO :XWORD
WSAResetEvent PROTO :XWORD
WSASend PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSASendDisconnect PROTO :XWORD,:XWORD
WSASendMsg PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSASendTo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSASetBlockingHook PROTO :XWORD
WSASetEvent PROTO :XWORD
WSASetLastError PROTO :XWORD
WSASetServiceA PROTO :XWORD,:XWORD,:XWORD
WSASetServiceW PROTO :XWORD,:XWORD,:XWORD
WSASocketA PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSASocketW PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAStartup PROTO :XWORD,:XWORD
WSAStringToAddressA PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAStringToAddressW PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSAUnadvertiseProvider PROTO :XWORD
WSAUnhookBlockingHook PROTO
WSAWaitForMultipleEvents PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSApSetPostRoutine PROTO :XWORD
WSCDeinstallProvider PROTO :XWORD,:XWORD
WSCDeinstallProvider32 PROTO :XWORD,:XWORD
WSCEnableNSProvider PROTO :XWORD,:XWORD
WSCEnableNSProvider32 PROTO :XWORD,:XWORD
WSCEnumNameSpaceProviders32 PROTO :XWORD,:XWORD
WSCEnumNameSpaceProvidersEx32 PROTO :XWORD,:XWORD
WSCEnumProtocols PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSCEnumProtocols32 PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSCGetApplicationCategory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCGetProviderInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCGetProviderInfo32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCGetProviderPath PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSCGetProviderPath32 PROTO :XWORD,:XWORD,:XWORD,:XWORD
WSCInstallNameSpace PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCInstallNameSpace32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCInstallNameSpaceEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCInstallNameSpaceEx32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCInstallProvider PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCInstallProvider64_32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCInstallProviderAndChains64_32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCSetApplicationCategory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCSetProviderInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCSetProviderInfo32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCUnInstallNameSpace PROTO :XWORD
WSCUnInstallNameSpace32 PROTO :XWORD
WSCUpdateProvider PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCUpdateProvider32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WSCWriteNameSpaceOrder PROTO :XWORD,:XWORD
WSCWriteNameSpaceOrder32 PROTO :XWORD,:XWORD
WSCWriteProviderOrder PROTO :XWORD,:XWORD
WSCWriteProviderOrder32 PROTO :XWORD,:XWORD
WahCloseApcHelper PROTO :XWORD
WahCloseHandleHelper PROTO :XWORD
WahCloseNotificationHandleHelper PROTO :XWORD
WahCloseSocketHandle PROTO :XWORD,:XWORD
WahCloseThread PROTO :XWORD,:XWORD
WahCompleteRequest PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
WahCreateHandleContextTable PROTO :XWORD
WahCreateNotificationHandle PROTO :XWORD,:XWORD
WahCreateSocketHandle PROTO :XWORD,:XWORD
WahDestroyHandleContextTable PROTO :XWORD
WahDisableNonIFSHandleSupport PROTO
WahEnableNonIFSHandleSupport PROTO
WahEnumerateHandleContexts PROTO :XWORD,:XWORD,:XWORD
WahInsertHandleContext PROTO :XWORD,:XWORD
WahNotifyAllProcesses PROTO :XWORD
WahOpenApcHelper PROTO :XWORD
WahOpenCurrentThread PROTO :XWORD,:XWORD
WahOpenHandleHelper PROTO :XWORD
WahOpenNotificationHandleHelper PROTO :XWORD
WahQueueUserApc PROTO :XWORD,:XWORD,:XWORD,:XWORD
WahReferenceContextByHandle PROTO :XWORD,:XWORD
WahRemoveHandleContext PROTO :XWORD,:XWORD
WahWaitForNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD
__WSAFDIsSet PROTO :XWORD,:XWORD
accept PROTO :XWORD,:XWORD,:XWORD
bind PROTO :XWORD,:XWORD,:XWORD
closesocket PROTO :XWORD
connect PROTO :XWORD,:XWORD,:XWORD
freeaddrinfo PROTO :XWORD
getaddrinfo PROTO :XWORD,:XWORD,:XWORD,:XWORD
gethostbyaddr PROTO :XWORD,:XWORD,:XWORD
gethostbyname PROTO :XWORD
gethostname PROTO :XWORD,:XWORD
getnameinfo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
getpeername PROTO :XWORD,:XWORD,:XWORD
getprotobyname PROTO :XWORD
getprotobynumber PROTO :XWORD
getservbyname PROTO :XWORD,:XWORD
getservbyport PROTO :XWORD,:XWORD
getsockname PROTO :XWORD,:XWORD,:XWORD
getsockopt PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
htonl PROTO :XWORD
htons PROTO :XWORD
inet_addr PROTO :XWORD
inet_ntoa PROTO :XWORD
ioctlsocket PROTO :XWORD,:XWORD,:XWORD
listen PROTO :XWORD,:XWORD
ntohl PROTO :XWORD
ntohs PROTO :XWORD
recv PROTO :XWORD,:XWORD,:XWORD,:XWORD
recvfrom PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
select PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
send PROTO :XWORD,:XWORD,:XWORD,:XWORD
sendto PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
setsockopt PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
shutdown PROTO :XWORD,:XWORD
socket PROTO :XWORD,:XWORD,:XWORD

IFDEF APP_UNICODE
    WSAPROTOCOL_INFO EQU <WSAPROTOCOL_INFOW>
    SERVICE_TYPE_VALUE_SAPID EQU <SERVICE_TYPE_VALUE_SAPIDW>
    SERVICE_TYPE_VALUE_TCPPORT EQU <SERVICE_TYPE_VALUE_TCPPORTW>
    SERVICE_TYPE_VALUE_UDPPORT EQU <SERVICE_TYPE_VALUE_UDPPORTW>
    SERVICE_TYPE_VALUE_OBJECTID EQU <SERVICE_TYPE_VALUE_OBJECTIDW>
    WSAQUERYSET EQU <WSAQUERYSETW>
    WSANSCLASSINFO EQU <WSANSCLASSINFOW>
    WSASERVICECLASSINFO EQU <WSASERVICECLASSINFOW>
    WSANAMESPACE_INFO EQU <WSANAMESPACE_INFOW>

    GetAddrInfoEx EQU <GetAddrInfoExW>
    SetAddrInfoEx EQU <SetAddrInfoExW>
    WSAAddressToString EQU <WSAAddressToStringW>
    WSAConnectByName EQU <WSAConnectByNameW>
    WSADuplicateSocket EQU <WSADuplicateSocketW>
    WSAEnumNameSpaceProviders EQU <WSAEnumNameSpaceProvidersW>
    WSAEnumNameSpaceProvidersEx EQU <WSAEnumNameSpaceProvidersExW>
    WSAEnumProtocols EQU <WSAEnumProtocolsW>
    WSAGetServiceClassInfo EQU <WSAGetServiceClassInfoW>
    WSAGetServiceClassNameByClassId EQU <WSAGetServiceClassNameByClassIdW>
    WSAInstallServiceClass EQU <WSAInstallServiceClassW>
    WSALookupServiceBegin EQU <WSALookupServiceBeginW>
    WSALookupServiceNext EQU <WSALookupServiceNextW>
    WSASetService EQU <WSASetServiceW>
    WSASocket EQU <WSASocketW>
    WSAStringToAddress EQU <WSAStringToAddressW>
ELSE
    WSAPROTOCOL_INFO EQU <WSAPROTOCOL_INFOA>
    SERVICE_TYPE_VALUE_SAPID EQU <SERVICE_TYPE_VALUE_SAPIDA>
    SERVICE_TYPE_VALUE_TCPPORT EQU <SERVICE_TYPE_VALUE_TCPPORTA>
    SERVICE_TYPE_VALUE_UDPPORT EQU <SERVICE_TYPE_VALUE_UDPPORTA>
    SERVICE_TYPE_VALUE_OBJECTID EQU <SERVICE_TYPE_VALUE_OBJECTIDA>
    WSAQUERYSET EQU <WSAQUERYSETA>
    WSANSCLASSINFO EQU <WSANSCLASSINFOA>
    WSASERVICECLASSINFO EQU <WSASERVICECLASSINFOA>
    WSANAMESPACE_INFO EQU <WSANAMESPACE_INFOA>

    GetAddrInfoEx EQU <GetAddrInfoExA>
    SetAddrInfoEx EQU <SetAddrInfoExA>
    WSAAddressToString EQU <WSAAddressToStringA>
    WSAConnectByName EQU <WSAConnectByNameA>
    WSADuplicateSocket EQU <WSADuplicateSocketA>
    WSAEnumNameSpaceProviders EQU <WSAEnumNameSpaceProvidersA>
    WSAEnumNameSpaceProvidersEx EQU <WSAEnumNameSpaceProvidersExA>
    WSAEnumProtocols EQU <WSAEnumProtocolsA>
    WSAGetServiceClassInfo EQU <WSAGetServiceClassInfoA>
    WSAGetServiceClassNameByClassId EQU <WSAGetServiceClassNameByClassIdA>
    WSAInstallServiceClass EQU <WSAInstallServiceClassA>
    WSALookupServiceBegin EQU <WSALookupServiceBeginA>
    WSALookupServiceNext EQU <WSALookupServiceNextA>
    WSASetService EQU <WSASetServiceA>
    WSASocket EQU <WSASocketA>
    WSAStringToAddress EQU <WSAStringToAddressA>
ENDIF

;======================= Undocumented functions (unknown arguments) =======================;
;WPUGetProviderPathEx PROTO
;WSCDeinstallProviderEx PROTO
;WSCEnumProtocolsEx PROTO
;WSCGetApplicationCategoryEx
;WSCInstallNameSpaceEx2 PROTO
;WSCInstallProviderEx PROTO
;WSCSetApplicationCategoryEx PROTO
;WSCUnInstallNameSpaceEx2 PROTO
;WSCUpdateProviderEx PROTO
;WSCWriteProviderOrderEx PROTO
;WahWriteLSPEvent PROTO
;inet_ntop PROTO
;inet_pton PROTO

ENDIF ;WS2_32_INC
